/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKukuServices implements KukuServiceInterface
type FakeKukuServices struct {
	Fake *FakeKumoriV1
	ns   string
}

var kukuservicesResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "kukuservices"}

var kukuservicesKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "KukuService"}

// Get takes name of the kukuService, and returns the corresponding kukuService object, and an error if there is any.
func (c *FakeKukuServices) Get(name string, options v1.GetOptions) (result *kumoriv1.KukuService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kukuservicesResource, c.ns, name), &kumoriv1.KukuService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuService), err
}

// List takes label and field selectors, and returns the list of KukuServices that match those selectors.
func (c *FakeKukuServices) List(opts v1.ListOptions) (result *kumoriv1.KukuServiceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kukuservicesResource, kukuservicesKind, c.ns, opts), &kumoriv1.KukuServiceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.KukuServiceList{ListMeta: obj.(*kumoriv1.KukuServiceList).ListMeta}
	for _, item := range obj.(*kumoriv1.KukuServiceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kukuServices.
func (c *FakeKukuServices) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kukuservicesResource, c.ns, opts))

}

// Create takes the representation of a kukuService and creates it.  Returns the server's representation of the kukuService, and an error, if there is any.
func (c *FakeKukuServices) Create(kukuService *kumoriv1.KukuService) (result *kumoriv1.KukuService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kukuservicesResource, c.ns, kukuService), &kumoriv1.KukuService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuService), err
}

// Update takes the representation of a kukuService and updates it. Returns the server's representation of the kukuService, and an error, if there is any.
func (c *FakeKukuServices) Update(kukuService *kumoriv1.KukuService) (result *kumoriv1.KukuService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kukuservicesResource, c.ns, kukuService), &kumoriv1.KukuService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuService), err
}

// Delete takes name of the kukuService and deletes it. Returns an error if one occurs.
func (c *FakeKukuServices) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kukuservicesResource, c.ns, name), &kumoriv1.KukuService{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKukuServices) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kukuservicesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.KukuServiceList{})
	return err
}

// Patch applies the patch and returns the patched kukuService.
func (c *FakeKukuServices) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.KukuService, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kukuservicesResource, c.ns, name, pt, data, subresources...), &kumoriv1.KukuService{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuService), err
}
